
// AutomCli.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "AutomCli.h"
#include "MainFrm.h"

#include "AutomCliDoc.h"
#include "AutomCliView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAutomCliApp

BEGIN_MESSAGE_MAP(CAutomCliApp, CWinApp)
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, &CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, &CWinApp::OnFileOpen)
END_MESSAGE_MAP()


// CAutomCliApp construction

CAutomCliApp::CAutomCliApp()
{
	// TODO: replace application ID string below with unique ID string; recommended
	// format for string is CompanyName.ProductName.SubProduct.VersionInformation
	SetAppID(_T("AutomCli.AppID.NoVersion"));

	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

// The one and only CAutomCliApp object

CAutomCliApp theApp;
// This identifier was generated to be statistically unique for your app
// You may change it if you prefer to choose a specific identifier

// {66722DA6-1A83-4A08-81BB-C128E763230B}
static const CLSID clsid =
{ 0x66722DA6, 0x1A83, 0x4A08, { 0x81, 0xBB, 0xC1, 0x28, 0xE7, 0x63, 0x23, 0xB } };

const GUID CDECL _tlid = { 0x3801C682, 0x4248, 0x4501, { 0xA0, 0x9F, 0x5F, 0x97, 0xD6, 0x89, 0xEA, 0x2E } };
const WORD _wVerMajor = 1;
const WORD _wVerMinor = 0;


CLSID CAutomCliApp::GetAppCLSID(void) {
  return clsid;
}

// CAutomCliApp initialization

BOOL CAutomCliApp::InitInstance()
{
	// InitCommonControlsEx() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// Set this to include all the common control classes you want to use
	// in your application.
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinApp::InitInstance();

	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

  EnableShellOpen(); // Allow recive DDE commands

#if defined(_MSC_VER) && (_MSC_VER >= 1600) // >= VS2010
  EnableTaskbarInteraction(FALSE);
#endif

	// AfxInitRichEdit2() is required to use RichEdit control
	// AfxInitRichEdit2();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));
	LoadStdProfileSettings(4);  // Load standard INI file options (including MRU)

  { // Register your unique class name that you wish to use
    WNDCLASS wndcls; ZeroMemory(&wndcls, sizeof(wndcls));
    wndcls.style = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
    wndcls.lpfnWndProc   = AfxWndProc;
    wndcls.hInstance     = AfxGetInstanceHandle();
    wndcls.hIcon         = LoadIcon(IDR_MAINFRAME); // or load a different icon
    wndcls.hCursor       = LoadCursor( IDC_ARROW );

    // Specify your own class name for using FindWindow later
    wndcls.lpszClassName = MY_OWN_WINDOWCLASS;

    // Register the new class and exit if it fails
    if(!AfxRegisterClass(&wndcls)) {
      TRACE( _T("Class Registration Failed\n") );
      return false;
    }
  }

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CAutomCliDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CAutomCliView));
	if (!pDocTemplate)
		return FALSE;
	AddDocTemplate(pDocTemplate);
	// Connect the COleTemplateServer to the document template
	//  The COleTemplateServer creates new documents on behalf
	//  of requesting OLE containers by using information
	//  specified in the document template
	m_server.ConnectTemplate(clsid, pDocTemplate, TRUE);
		// Note: SDI applications register server objects only if /Embedding
		//   or /Automation is present on the command line


	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

#if defined(_MSC_VER) && (_MSC_VER >= 1500) // No VS2005
  // Avoid need for running in elevated mode by redirecting registry access from HKCR to HKCU
  AfxSetPerUserRegistration( true /*cmdInfo.m_bRegisterPerUser || ! IsRunAsAdmin()*/ );
#endif

	// App was launched with /Embedding or /Automation switch.
	// Run app as automation server.
	if (cmdInfo.m_bRunEmbedded || cmdInfo.m_bRunAutomated)
	{
		// Register all OLE server factories as running.  This enables the
		//  OLE libraries to create objects from other applications
		COleTemplateServer::RegisterAll();

		// Don't show the main window
		return TRUE;
	}
	// App was launched with /Unregserver or /Unregister switch.  Unregister
	// typelibrary.  Other unregistration occurs in ProcessShellCommand().
	else if (cmdInfo.m_nShellCommand == CCommandLineInfo::AppUnregister)
	{
		m_server.UpdateRegistry(OAT_DISPATCH_OBJECT, NULL, NULL, FALSE);
		AfxOleUnregisterTypeLib(_tlid, _wVerMajor, _wVerMinor);
	}
	// App was launched standalone or with other switches (e.g. /Register
	// or /Regserver).  Update registry entries, including typelibrary.
	else
	{
		m_server.UpdateRegistry(OAT_DISPATCH_OBJECT);
		COleObjectFactory::UpdateRegistryAll();
		AfxOleRegisterTypeLib(AfxGetInstanceHandle(), _tlid);
	}

	// Dispatch commands specified on the command line.  Will return FALSE if
	// app was launched with /RegServer, /Register, /Unregserver or /Unregister.
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	return TRUE;
}

int CAutomCliApp::ExitInstance()
{
	//TODO: handle additional resources you may have added
	AfxOleTerm(FALSE);
	return CWinApp::ExitInstance();
}

// CAutomCliApp message handlers

BOOL CAutomCliApp::OnDDECommand( LPTSTR lpszCommand )
{
  ShowIncommingCommand( _T("DDE: ") + CString(lpszCommand) );

  if (m_pDocManager != NULL)
    return m_pDocManager->OnDDECommand(lpszCommand);
  else
    return FALSE;
}