
// AutomCliDoc.cpp : implementation of the CAutomCliDoc class
//

#include "stdafx.h"
#include "AutomCli.h"

#include "AutomCliDoc.h"

#include <propkey.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAutomCliDoc

IMPLEMENT_DYNCREATE(CAutomCliDoc, CDocument)

BEGIN_MESSAGE_MAP(CAutomCliDoc, CDocument)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CAutomCliDoc, CDocument)
  DISP_FUNCTION(CAutomCliDoc, "ExecuteFromTelemator", ExecuteFromTelemator, VT_BSTR, VTS_BSTR VTS_BSTR)
END_DISPATCH_MAP()

// Note: we add support for IID_IAutomCli to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the
//  dispinterface in the .IDL file.

// {5139E0AC-FA59-4145-B4B1-0811279A7F1A}
static const IID IID_IAutomCli =
{ 0x5139E0AC, 0xFA59, 0x4145, { 0xB4, 0xB1, 0x8, 0x11, 0x27, 0x9A, 0x7F, 0x1A } };

BEGIN_INTERFACE_MAP(CAutomCliDoc, CDocument)
	INTERFACE_PART(CAutomCliDoc, IID_IAutomCli, Dispatch)
END_INTERFACE_MAP()


// CAutomCliDoc construction/destruction

CAutomCliDoc::CAutomCliDoc():
m_dwCookie(0),
m_bLockedExternal(FALSE)
{
	// TODO: add one-time construction code here

	EnableAutomation();

	AfxOleLockApp();
}

CAutomCliDoc::~CAutomCliDoc()
{
	AfxOleUnlockApp();
}

BOOL CAutomCliDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

  //Register new documents as running so controllers can connect to it.
  RegisterAsActive();
	return TRUE;
}

void CAutomCliDoc::OnCloseDocument()
{
  // TODO: Add your specialized code here and/or call the base class
  TRACE0( "CAutomCliDoc::OnCloseDocument\n" );

  //If we didn't throw an external lock on, we can just
  //close the document normally, otherwise, we should
  //unlock our document using CoLockObjectExternal.  We
  //are registered as ACTIVEOBJECT_WEAK so in this instance
  //unlocking the object with CoLockObjectExternal will be
  //the last reference count on the object which will remove
  //it from the ROT.
  if(!m_bLockedExternal)
    CDocument::OnCloseDocument();
  else {
    m_bLockedExternal = FALSE;
    CoLockObjectExternal(GetControllingUnknown(),FALSE,TRUE);
  }
  RevokeActiveObject( m_dwCookie, NULL );
}

// CAutomCliDoc diagnostics

#ifdef _DEBUG
void CAutomCliDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CAutomCliDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


// CAutomCliDoc commands

/////////////////////////////////////////////////////////////////////////////
// CAutomCliDoc commands

extern HWND g_hCtlIncomming;

void ShowIncommingCommand( CString str )
{
  if( ::IsWindow(g_hCtlIncomming) ) {
    str.Remove('\r');
    str.Replace(_T("\n"), _T("\r\n")); // EditBox needs \r to show \n

    TCHAR sz[9999]; ::GetWindowText( g_hCtlIncomming, sz, _countof(sz) );
    ::SetWindowText(g_hCtlIncomming, str + _T("\r\n") + CString(sz));
  }
}

BSTR CAutomCliDoc::ExecuteFromTelemator(LPCTSTR pszCmd, LPCTSTR pszArg)
{
  // TODO: Add your dispatch handler code here
  CString str; str.Format( _T("%s(%s)"), pszCmd, pszArg );
  ShowIncommingCommand( str );

  if( 0==_tcsicmp(pszCmd,_T("Test_RPC_E_SERVERFAULT") ) )
    AfxThrowOleException(RPC_E_SERVERFAULT);

  if( 0==_tcsicmp(pszCmd,_T("Test_AskBack") ) ) {
    Test_GetObjectExecuteFromGis( _T("GetOdbcConnectString"), _T("1") );
    Test_GetObjectExecuteFromGis( _T("GetOdbcConnectString"), _T("2") );
    Test_GetObjectExecuteFromGis( _T("GetOdbcConnectString"), _T("3") );
  }

  if( 0==_tcsicmp(pszCmd,_T("Test_Hang") ) ) {
    AfxMessageBox( _T("Hanging until you press OK"));
    // ::Sleep( 2 /*min*/ * 60 /*sec*/ * 1000 /*ms*/ ); // 2 minutter
    // for( ;; ) { /* Infinite loop here */ }
  }

  CString strResult = _T("0 Have a nice day!");
	return strResult.AllocSysString();
}

DWORD CAutomCliDoc::GetRefCount(void) {
  return m_dwRef;
}

extern CString AFXAPI AfxStringFromCLSID(REFCLSID rclsid);

void CAutomCliDoc::RegisterAsActive(void) // From REGAUT.EXE sample
{
  // This helper function actually registers our
  // object as running in the running object table (ROT).
  // Register the object by passing the IUnknown pointer
  // to the object and the CLSID from our CWinApp object
  // which was given to us by AppWizard
  CAutomCliApp* pApp  = (CAutomCliApp*)AfxGetApp();
  IUnknown  * pCU   = GetControllingUnknown();
  CLSID       clsid = pApp->GetAppCLSID();
  HRESULT hr=RegisterActiveObject( pCU, clsid,
              //ACTIVEOBJECT_WEAK,
              ACTIVEOBJECT_STRONG, // Strong also needs RevokeActiveObject
              &m_dwCookie);

  if( 0 ) {
    CString strCLSID = AfxStringFromCLSID( clsid );
    CString str;
    str.Format( _T("%x (failed(%x)=%s) =\n")
                _T(" = RegisterActiveObject(\n\t")
                _T("GetControllingUnknown=%x\n\t")
                _T("clsid=%s\n\t")
                _T("strong=%x\n\t")
                _T("cookie out=%x)"),
                (int)hr, (int)hr,
                (LPCTSTR)(FAILED(hr) ? _T("true") : _T("false")),
                (int)pCU, (LPCTSTR)strCLSID,
                (int)ACTIVEOBJECT_STRONG, (int)m_dwCookie );
    AfxMessageBox( str );
  }

  if( FAILED(hr) )
    AfxMessageBox(_T("Didn't register Active Object"));
}
