
// AutomCliView.h : interface of the CAutomCliView class
//

#pragma once

#include "resource.h"
#include <vector>


class CAutomCliView : public CFormView
{
protected: // create from serialization only
	CAutomCliView();
	DECLARE_DYNCREATE(CAutomCliView)

public:
	enum{ IDD = IDD_AUTOMCLI_FORM };

// Attributes
public:
	CAutomCliDoc* GetDocument() const;

// Operations
public:
  class CElmCmdList { public: 
    CString m_sCmd, m_sArg; 
    CElmCmdList( const CString& sC=CString(), const CString& sA = CString()) { m_sCmd =sC; m_sArg=sA; }
  };
  std::vector<CElmCmdList> m_vCmdList;
  void CmdList_FillDefault(void);
  void CmdList_TransferToComboBox(void);

// Overrides
public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct

// Implementation
    void UpdateResultWindows( const CString& strRes, TCHAR chSplitResult );

public:
	virtual ~CAutomCliView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
  afx_msg void OnCbnCmdTextSelEndOk();
  afx_msg void OnSendCommandToTelematorHttpJson();
  afx_msg void OnSendCommandToTelematorFromGis();
  afx_msg void OnSendCommandToTelemator();
  afx_msg void OnSendManyCmdsToTelemator();
  afx_msg void OnSetForegroundWindowTelemator();

	DECLARE_MESSAGE_MAP()

public:
  afx_msg void OnBnClickedCombusystate();
};

#ifndef _DEBUG  // debug version in AutomCliView.cpp
inline CAutomCliDoc* CAutomCliView::GetDocument() const
   { return reinterpret_cast<CAutomCliDoc*>(m_pDocument); }
#endif

